Index: uspace/app/taskdump/elf_core.c
===================================================================
--- uspace/app/taskdump/elf_core.c	(revision e27cf669cb84d831da5b56f6fc99cd623239ba41)
+++ uspace/app/taskdump/elf_core.c	(revision e27cf669cb84d831da5b56f6fc99cd623239ba41)
@@ -0,0 +1,287 @@
+/*
+ * Copyright (c) 2010 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup taskdump
+ * @{
+ */
+/** @file Write ELF core files.
+ *
+ * Creates ELF core files. Core files do not seem to be specified by some
+ * standard (the System V ABI explicitely states that it does not specify
+ * them).
+ *
+ * Looking at core files produced by Linux, these don't have section headers,
+ * only program headers, although objdump shows them as having sections.
+ * Basically at the beginning there should be a note segment (which we
+ * do not write) and one loadable segment per memory area (which we do write).
+ *
+ * The note segment probably contains register state, etc. -- we don't
+ * deal with these yet. Nevertheless you can use these core files with
+ * objdump or gdb.
+ */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <errno.h>
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <unistd.h>
+#include <fcntl.h>
+#include <mem.h>
+#include <stdint.h>
+#include <as.h>
+#include <udebug.h>
+#include <macros.h>
+
+#include <elf.h>
+#include "include/elf_core.h"
+
+static off_t align_foff_up(off_t foff, uintptr_t vaddr, size_t page_size);
+static int write_all(int fd, void *data, size_t len);
+static int write_mem_area(int fd, as_area_info_t *area, int phoneid);
+
+#define BUFFER_SIZE 0x1000
+static uint8_t buffer[BUFFER_SIZE];
+
+/** Save ELF core file.
+ *
+ * @param file_name	Name of file to save to.
+ * @param ainfo		Array of @a n memory area info structures.
+ * @param n		Number of memory areas.
+ * @param phoneid	Debugging phone.
+ *
+ * @return		EOK on sucess, ENOENT if file cannot be created,
+ *			ENOMEM on out of memory, EIO on write error.
+ */
+int elf_core_save(const char *file_name, as_area_info_t *ainfo, int n, int phoneid)
+{
+	elf_header_t elf_hdr;
+	off_t foff;
+	size_t n_ph;
+	elf_word flags;
+	elf_segment_header_t *p_hdr;
+
+	int fd;
+	int rc;
+	int i;
+
+	n_ph = n;
+
+	p_hdr = malloc(sizeof(elf_segment_header_t) * n);
+	if (p_hdr == NULL) {
+		printf("Failed allocating memory.\n");
+		return ENOMEM;
+	}
+
+	fd = open(file_name, O_CREAT | O_WRONLY, 0644);
+	if (fd < 0) {
+		printf("Failed opening file.\n");
+		free(p_hdr);
+		return ENOENT;
+	}
+
+	/*
+	 * File layout:
+	 *
+	 * 	ELF header
+	 *	program headers
+	 * repeat:
+	 *	(pad for alignment)
+	 *	segment data
+	 * end repeat
+	 */
+
+	memset(&elf_hdr, 0, sizeof(elf_hdr));
+	elf_hdr.e_ident[EI_MAG0] = ELFMAG0;
+	elf_hdr.e_ident[EI_MAG1] = ELFMAG1;
+	elf_hdr.e_ident[EI_MAG2] = ELFMAG2;
+	elf_hdr.e_ident[EI_MAG3] = ELFMAG3;
+	elf_hdr.e_ident[EI_CLASS] = ELF_CLASS;
+	elf_hdr.e_ident[EI_DATA] = ELF_DATA_ENCODING;
+	elf_hdr.e_ident[EI_VERSION] = EV_CURRENT;
+
+	elf_hdr.e_type = ET_CORE;
+	elf_hdr.e_machine = ELF_MACHINE;
+	elf_hdr.e_version = EV_CURRENT;
+	elf_hdr.e_entry = 0;
+	elf_hdr.e_phoff = sizeof(elf_header_t);
+	elf_hdr.e_shoff = 0;
+	elf_hdr.e_flags = 0;
+	elf_hdr.e_ehsize = sizeof(elf_hdr);
+	elf_hdr.e_phentsize = sizeof(elf_segment_header_t);
+	elf_hdr.e_phnum = n_ph;
+	elf_hdr.e_shentsize = 0;
+	elf_hdr.e_shnum = 0;
+	elf_hdr.e_shstrndx = 0;
+
+	/* foff is used for allocation of file space for segment data. */
+	foff = elf_hdr.e_phoff + n_ph * sizeof(elf_segment_header_t);
+
+	for (i = 1; i <= n; ++i) {
+		foff = align_foff_up(foff, ainfo[i - 1].start_addr, PAGE_SIZE);
+
+		flags = 0;
+		if (ainfo[i - 1].flags & AS_AREA_READ)
+			flags |= PF_R;
+		if (ainfo[i - 1].flags & AS_AREA_WRITE)
+			flags |= PF_W;
+		if (ainfo[i - 1].flags & AS_AREA_EXEC)
+			flags |= PF_X;
+
+		memset(&p_hdr[i - 1], 0, sizeof(p_hdr[i - 1]));
+		p_hdr[i - 1].p_type = PT_LOAD;
+		p_hdr[i - 1].p_offset = foff;
+		p_hdr[i - 1].p_vaddr = ainfo[i - 1].start_addr;
+		p_hdr[i - 1].p_paddr = 0;
+		p_hdr[i - 1].p_filesz = ainfo[i - 1].size;
+		p_hdr[i - 1].p_memsz = ainfo[i - 1].size;
+		p_hdr[i - 1].p_flags = flags;
+		p_hdr[i - 1].p_align = PAGE_SIZE;
+
+		foff += ainfo[i - 1].size;
+	}
+
+	rc = write_all(fd, &elf_hdr, sizeof(elf_hdr));
+	if (rc != EOK) {
+		printf("Failed writing ELF header.\n");
+		free(p_hdr);
+		return EIO;
+	}
+
+	for (i = 0; i < n_ph; ++i) {
+		rc = write_all(fd, &p_hdr[i], sizeof(p_hdr[i]));
+		if (rc != EOK) {
+			printf("Failed writing program header.\n");
+			free(p_hdr);
+			return EIO;
+		}
+	}
+
+	for (i = 0; i < n_ph; ++i) {
+		if (lseek(fd, p_hdr[i].p_offset, SEEK_SET) == (off_t) -1) {
+			printf("Failed writing memory data.\n");
+			free(p_hdr);
+			return EIO;
+		}
+		if (write_mem_area(fd, &ainfo[i], phoneid) != EOK) {
+			printf("Failed writing memory data.\n");
+			free(p_hdr);
+			return EIO;
+		}
+	}
+
+	free(p_hdr);
+
+	return EOK;
+}
+
+/** Align file offset up to be congruent with vaddr modulo page size. */
+static off_t align_foff_up(off_t foff, uintptr_t vaddr, size_t page_size)
+{
+	off_t rfo, rva;
+	off_t advance;
+
+	rva = vaddr % page_size;
+	rfo = foff % page_size;
+
+	advance = (rva >= rfo) ? rva - rfo : (page_size + rva - rfo);
+	return foff + advance;
+}
+
+/** Write memory area from application to core file.
+ *
+ * @param fd		File to write to.
+ * @param area		Memory area info structure.
+ * @param phoneid	Debugging phone.
+ *
+ * @return		EOK on success, EIO on failure.
+ */
+static int write_mem_area(int fd, as_area_info_t *area, int phoneid)
+{
+	size_t to_copy;
+	size_t total;
+	uintptr_t addr;
+	int rc;
+
+	addr = area->start_addr;
+	total = 0;
+
+	while (total < area->size) {
+		to_copy = min(area->size - total, BUFFER_SIZE);
+		rc = udebug_mem_read(phoneid, buffer, addr, to_copy);
+		if (rc < 0) {
+			printf("Failed reading task memory.\n");
+			return EIO;
+		}
+
+		rc = write_all(fd, buffer, to_copy);
+		if (rc != EOK) {
+			printf("Failed writing memory contents.\n");
+			return EIO;
+		}
+
+		addr += to_copy;
+		total += to_copy;
+	}
+
+	return EOK;
+}
+
+/** Write until the buffer is written in its entirety.
+ *
+ * This function fails if it cannot write exactly @a len bytes to the file.
+ *
+ * @param fd		The file to write to.
+ * @param buf		Data, @a len bytes long.
+ * @param len		Number of bytes to write.
+ *
+ * @return		EOK on error, return value from write() if writing
+ *			failed.
+ */
+static int write_all(int fd, void *data, size_t len)
+{
+	int cnt = 0;
+
+	do {
+		data += cnt;
+		len -= cnt;
+		cnt = write(fd, data, len);
+	} while (cnt > 0 && (len - cnt) > 0);
+
+	if (cnt < 0)
+		return cnt;
+
+	if (len - cnt > 0)
+		return EIO;
+
+	return EOK;
+}
+
+
+/** @}
+ */
Index: uspace/app/taskdump/include/elf.h
===================================================================
--- uspace/app/taskdump/include/elf.h	(revision e27cf669cb84d831da5b56f6fc99cd623239ba41)
+++ uspace/app/taskdump/include/elf.h	(revision e27cf669cb84d831da5b56f6fc99cd623239ba41)
@@ -0,0 +1,349 @@
+/*
+ * Copyright (c) 2006 Sergey Bondari
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup generic	
+ * @{
+ */
+/** @file
+ */
+
+#ifndef ELF_H_
+#define ELF_H_
+
+#include <arch/elf.h>
+#include <sys/types.h>
+
+/**
+ * current ELF version
+ */
+#define	EV_CURRENT	1
+
+/** 
+ * ELF types 
+ */
+#define ET_NONE		0	/* No type */
+#define ET_REL		1	/* Relocatable file */
+#define ET_EXEC		2	/* Executable */
+#define ET_DYN		3	/* Shared object */
+#define ET_CORE		4	/* Core */
+#define ET_LOPROC	0xff00	/* Processor specific */
+#define ET_HIPROC	0xffff	/* Processor specific */
+
+/** 
+ * ELF machine types
+ */
+#define EM_NO		0	/* No machine */
+#define EM_SPARC	2	/* SPARC */
+#define EM_386		3	/* i386 */
+#define EM_MIPS		8	/* MIPS RS3000 */
+#define EM_MIPS_RS3_LE	10	/* MIPS RS3000 LE */
+#define EM_PPC		20	/* PPC32 */
+#define EM_PPC64	21	/* PPC64 */
+#define EM_ARM		40	/* ARM */
+#define EM_SPARCV9	43	/* SPARC64 */
+#define EM_IA_64	50	/* IA-64 */
+#define EM_X86_64	62	/* AMD64/EMT64 */
+
+/**
+ * ELF identification indexes
+ */
+#define EI_MAG0		0
+#define EI_MAG1		1
+#define EI_MAG2		2
+#define EI_MAG3		3
+#define EI_CLASS	4		/* File class */
+#define EI_DATA		5		/* Data encoding */
+#define EI_VERSION	6		/* File version */
+#define EI_OSABI	7
+#define EI_ABIVERSION	8
+#define EI_PAD		9		/* Start of padding bytes */
+#define EI_NIDENT	16		/* ELF identification table size */
+
+/**
+ * ELF magic number
+ */
+#define ELFMAG0		0x7f
+#define ELFMAG1		'E'
+#define ELFMAG2		'L'
+#define ELFMAG3		'F'
+
+/**
+ * ELF file classes
+ */
+#define ELFCLASSNONE	0
+#define ELFCLASS32	1
+#define ELFCLASS64	2
+
+/**
+ * ELF data encoding types
+ */
+#define ELFDATANONE	0
+#define ELFDATA2LSB	1		/* Least significant byte first (little endian) */
+#define ELFDATA2MSB	2		/* Most signigicant byte first (big endian) */
+
+/**
+ * ELF error return codes
+ */
+#define EE_OK			0	/* No error */
+#define EE_INVALID		1	/* Invalid ELF image */
+#define	EE_MEMORY		2	/* Cannot allocate address space */
+#define EE_INCOMPATIBLE		3	/* ELF image is not compatible with current architecture */
+#define EE_UNSUPPORTED		4	/* Non-supported ELF (e.g. dynamic ELFs) */
+#define EE_IRRECOVERABLE	5
+
+/**
+ * ELF section types
+ */
+#define SHT_NULL		0
+#define SHT_PROGBITS		1
+#define SHT_SYMTAB		2
+#define SHT_STRTAB		3
+#define SHT_RELA		4
+#define SHT_HASH		5
+#define SHT_DYNAMIC		6
+#define SHT_NOTE		7
+#define SHT_NOBITS		8
+#define SHT_REL			9
+#define SHT_SHLIB		10
+#define SHT_DYNSYM		11
+#define SHT_LOOS		0x60000000
+#define SHT_HIOS		0x6fffffff
+#define SHT_LOPROC		0x70000000
+#define SHT_HIPROC		0x7fffffff
+#define SHT_LOUSER		0x80000000
+#define SHT_HIUSER		0xffffffff
+
+/**
+ * ELF section flags
+ */
+#define SHF_WRITE		0x1 
+#define SHF_ALLOC		0x2
+#define SHF_EXECINSTR		0x4
+#define SHF_TLS			0x400
+#define SHF_MASKPROC		0xf0000000
+
+/** Macros for decomposing elf_symbol.st_info into binging and type */
+#define ELF_ST_BIND(i)		((i) >> 4)
+#define ELF_ST_TYPE(i)		((i) & 0x0f)
+#define ELF_ST_INFO(b, t)	(((b) << 4) + ((t) & 0x0f))
+
+/**
+ * Symbol binding
+ */
+#define STB_LOCAL		0
+#define STB_GLOBAL		1
+#define STB_WEAK		2
+#define STB_LOPROC		13
+#define STB_HIPROC		15
+
+/**
+ * Symbol types
+ */
+#define STT_NOTYPE		0
+#define STT_OBJECT		1
+#define STT_FUNC		2
+#define STT_SECTION		3
+#define STT_FILE		4
+#define STT_LOPROC		13
+#define STT_HIPROC		15
+
+/**
+ * Program segment types
+ */
+#define PT_NULL			0
+#define PT_LOAD			1
+#define PT_DYNAMIC		2
+#define PT_INTERP		3
+#define PT_NOTE			4
+#define PT_SHLIB		5
+#define PT_PHDR			6
+#define PT_LOPROC		0x70000000
+#define PT_HIPROC		0x7fffffff
+
+/**
+ * Program segment attributes.
+ */
+#define PF_X	1
+#define PF_W	2
+#define PF_R	4
+
+/**
+ * ELF data types
+ *
+ * These types are found to be identical in both 32-bit and 64-bit
+ * ELF object file specifications. They are the only types used
+ * in ELF header.
+ */
+typedef uint64_t elf_xword;
+typedef int64_t elf_sxword;
+typedef uint32_t elf_word;
+typedef int32_t elf_sword;
+typedef uint16_t elf_half;
+
+/**
+ * 32-bit ELF data types.
+ *
+ * These types are specific for 32-bit format.
+ */
+typedef uint32_t elf32_addr;
+typedef uint32_t elf32_off;
+
+/**
+ * 64-bit ELF data types.
+ *
+ * These types are specific for 64-bit format.
+ */
+typedef uint64_t elf64_addr;
+typedef uint64_t elf64_off;
+
+/** ELF header */
+struct elf32_header {
+	uint8_t e_ident[EI_NIDENT];
+	elf_half e_type;
+	elf_half e_machine;
+	elf_word e_version;
+	elf32_addr e_entry;
+	elf32_off e_phoff;
+	elf32_off e_shoff;
+	elf_word e_flags;
+	elf_half e_ehsize;
+	elf_half e_phentsize;
+	elf_half e_phnum;
+	elf_half e_shentsize;
+	elf_half e_shnum;
+	elf_half e_shstrndx;
+};
+struct elf64_header {
+	uint8_t e_ident[EI_NIDENT];
+	elf_half e_type;
+	elf_half e_machine;
+	elf_word e_version;
+	elf64_addr e_entry;
+	elf64_off e_phoff;
+	elf64_off e_shoff;
+	elf_word e_flags;
+	elf_half e_ehsize;
+	elf_half e_phentsize;
+	elf_half e_phnum;
+	elf_half e_shentsize;
+	elf_half e_shnum;
+	elf_half e_shstrndx;
+};
+
+/*
+ * ELF segment header.
+ * Segments headers are also known as program headers.
+ */
+struct elf32_segment_header {
+	elf_word p_type;
+	elf32_off p_offset;
+	elf32_addr p_vaddr;
+	elf32_addr p_paddr;
+	elf_word p_filesz;
+	elf_word p_memsz;
+	elf_word p_flags;
+	elf_word p_align;
+};
+struct elf64_segment_header {
+	elf_word p_type;
+	elf_word p_flags;
+	elf64_off p_offset;
+	elf64_addr p_vaddr;
+	elf64_addr p_paddr;
+	elf_xword p_filesz;
+	elf_xword p_memsz;
+	elf_xword p_align;
+};
+
+/*
+ * ELF section header
+ */
+struct elf32_section_header {
+	elf_word sh_name;
+	elf_word sh_type;
+	elf_word sh_flags;
+	elf32_addr sh_addr;
+	elf32_off sh_offset;
+	elf_word sh_size;
+	elf_word sh_link;
+	elf_word sh_info;
+	elf_word sh_addralign;
+	elf_word sh_entsize;
+};
+struct elf64_section_header {
+	elf_word sh_name;
+	elf_word sh_type;
+	elf_xword sh_flags;
+	elf64_addr sh_addr;
+	elf64_off sh_offset;
+	elf_xword sh_size;
+	elf_word sh_link;
+	elf_word sh_info;
+	elf_xword sh_addralign;
+	elf_xword sh_entsize;
+};
+
+/*
+ * ELF symbol table entry
+ */
+struct elf32_symbol {
+	elf_word st_name;
+	elf32_addr st_value;
+	elf_word st_size;
+	uint8_t st_info;
+	uint8_t st_other;
+	elf_half st_shndx;
+};
+struct elf64_symbol {
+	elf_word st_name;
+	uint8_t st_info;
+	uint8_t st_other;
+	elf_half st_shndx;
+	elf64_addr st_value;
+	elf_xword st_size;
+};
+
+#ifdef __32_BITS__ 
+typedef struct elf32_header elf_header_t;
+typedef struct elf32_segment_header elf_segment_header_t;
+typedef struct elf32_section_header elf_section_header_t;
+typedef struct elf32_symbol elf_symbol_t;
+#endif
+#ifdef __64_BITS__
+typedef struct elf64_header elf_header_t;
+typedef struct elf64_segment_header elf_segment_header_t;
+typedef struct elf64_section_header elf_section_header_t;
+typedef struct elf64_symbol elf_symbol_t;
+#endif
+
+extern char *elf_error(unsigned int rc);
+
+#endif
+
+/** @}
+ */
Index: uspace/app/taskdump/include/elf_core.h
===================================================================
--- uspace/app/taskdump/include/elf_core.h	(revision e27cf669cb84d831da5b56f6fc99cd623239ba41)
+++ uspace/app/taskdump/include/elf_core.h	(revision e27cf669cb84d831da5b56f6fc99cd623239ba41)
@@ -0,0 +1,43 @@
+/*
+ * Copyright (c) 2010 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup debug
+ * @{
+ */
+/** @file
+ */
+
+#ifndef ELF_CORE_H_
+#define ELF_CORE_H_
+
+int elf_core_save(const char *file_name, as_area_info_t *ainfo, int n, int phoneid);
+
+#endif
+
+/** @}
+ */
Index: uspace/app/taskdump/include/symtab.h
===================================================================
--- uspace/app/taskdump/include/symtab.h	(revision e27cf669cb84d831da5b56f6fc99cd623239ba41)
+++ uspace/app/taskdump/include/symtab.h	(revision e27cf669cb84d831da5b56f6fc99cd623239ba41)
@@ -0,0 +1,59 @@
+/*
+ * Copyright (c) 2008 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup debug
+ * @{
+ */
+/** @file
+ */
+
+#ifndef SYMTAB_H_
+#define SYMTAB_H_
+
+#include <sys/types.h>
+#include <elf.h>
+
+typedef struct {
+	/** Symbol section */
+	elf_symbol_t *sym;
+	size_t sym_size;
+	/** String table */
+	char *strtab;
+	size_t strtab_size;
+} symtab_t;
+
+extern int symtab_load(const char *file_name, symtab_t **symtab);
+extern void symtab_delete(symtab_t *st);
+extern int symtab_name_to_addr(symtab_t *st, char *name, uintptr_t *addr);
+extern int symtab_addr_to_name(symtab_t *symtab, uintptr_t addr, char **name,
+    size_t *offs);
+
+#endif
+
+/** @}
+ */
Index: uspace/app/taskdump/symtab.c
===================================================================
--- uspace/app/taskdump/symtab.c	(revision e27cf669cb84d831da5b56f6fc99cd623239ba41)
+++ uspace/app/taskdump/symtab.c	(revision e27cf669cb84d831da5b56f6fc99cd623239ba41)
@@ -0,0 +1,389 @@
+/*
+ * Copyright (c) 2010 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup debug
+ * @{
+ */
+/** @file Handling of ELF symbol tables.
+ *
+ * This module allows one to load a symbol table from an ELF file and
+ * use it to lookup symbol names/addresses in both directions.
+ */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <errno.h>
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <fcntl.h>
+
+#include <elf.h>
+#include "include/symtab.h"
+
+static int elf_hdr_check(elf_header_t *hdr);
+static int section_hdr_load(int fd, const elf_header_t *ehdr, int idx,
+    elf_section_header_t *shdr);
+static int chunk_load(int fd, off_t start, off_t size, void **ptr);
+static int read_all(int fd, void *buf, size_t len);
+
+/** Load symbol table from an ELF file.
+ *
+ * @param file_name	Name of the ELF file to read from.
+ * @param symtab	Place to save pointer to new symtab structure.
+ *
+ * @return		EOK on success, ENOENT if file could not be open,
+ *			ENOTSUP if file parsing failed.
+ */
+int symtab_load(const char *file_name, symtab_t **symtab)
+{
+	symtab_t *stab;
+	elf_header_t elf_hdr;
+	elf_section_header_t sec_hdr;
+	off_t shstrt_start, shstrt_size;
+	char *shstrt, *sec_name;
+	void *data;
+
+	int fd;
+	int rc;
+	int i;
+
+	bool load_sec, sec_is_symtab;
+
+	*symtab = NULL;
+
+	stab = calloc(1, sizeof(symtab_t));
+	if (stab == NULL)
+		return ENOMEM;
+
+	fd = open(file_name, O_RDONLY);
+	if (fd < 0) {
+		printf("failed opening file\n");
+		free(stab);
+		return ENOENT;
+	}
+
+	rc = read_all(fd, &elf_hdr, sizeof(elf_header_t));
+	if (rc != EOK) {
+		printf("failed reading elf header\n");
+		free(stab);
+		return EIO;
+	}
+
+	rc = elf_hdr_check(&elf_hdr);
+	if (rc != EOK) {
+		printf("failed header check\n");
+		free(stab);
+		return ENOTSUP;
+	}
+
+	/*
+	 * Load section header string table.
+	 */
+
+	rc = section_hdr_load(fd, &elf_hdr, elf_hdr.e_shstrndx, &sec_hdr);
+	if (rc != EOK) {
+		printf("failed reading shstrt header\n");
+		free(stab);
+		return ENOTSUP;
+	}
+
+	shstrt_start = sec_hdr.sh_offset;
+	shstrt_size = sec_hdr.sh_size;
+
+	rc = chunk_load(fd, shstrt_start, shstrt_size, (void **) &shstrt);
+	if (rc != EOK) {
+		printf("failed loading shstrt\n");
+		free(stab);
+		return ENOTSUP;
+	}
+
+	/* Read all section headers. */
+	for (i = 0; i < elf_hdr.e_shnum; ++i) {
+		rc = section_hdr_load(fd, &elf_hdr, i, &sec_hdr);
+		if (rc != EOK) {
+			free(shstrt);
+			free(stab);
+			return ENOTSUP;
+		}
+
+		sec_name = shstrt + sec_hdr.sh_name;
+		if (str_cmp(sec_name, ".symtab") == 0 &&
+		    sec_hdr.sh_type == SHT_SYMTAB) {
+			load_sec = true;
+			sec_is_symtab = true;
+		} else if (str_cmp(sec_name, ".strtab") == 0 &&
+		    sec_hdr.sh_type == SHT_STRTAB) {
+			load_sec = true;
+			sec_is_symtab = false;
+		} else {
+			load_sec = false;
+		}
+
+		if (load_sec) {
+			rc = chunk_load(fd, sec_hdr.sh_offset, sec_hdr.sh_size,
+			    &data);
+			if (rc != EOK) {
+				free(shstrt);
+				free(stab);
+				return ENOTSUP;
+			}
+
+			if (sec_is_symtab) {
+				stab->sym = data;
+				stab->sym_size = sec_hdr.sh_size;
+			} else {
+				stab->strtab = data;
+				stab->strtab_size = sec_hdr.sh_size;
+			}
+		}
+	}
+
+	free(shstrt);
+	close(fd);
+
+	if (stab->sym == NULL || stab->strtab == NULL) {
+		/* Tables not found. */
+		printf("Symbol table or string table section not found\n");
+		free(stab);
+		return ENOTSUP;
+	}
+
+	*symtab = stab;
+
+	return EOK;
+}
+
+/** Delete a symtab structure.
+ *
+ * Deallocates all resources used by the symbol table.
+ */
+void symtab_delete(symtab_t *st)
+{
+	free(st->sym);
+	st->sym = NULL;
+
+	free(st->strtab);
+	st->strtab = NULL;
+
+	free(st);
+}
+
+/** Convert symbol name to address.
+ *
+ * @param st	Symbol table.
+ * @param name	Name of the symbol.
+ * @param addr	Place to store address for symbol, if found.
+ *
+ * @return	EOK on success, ENOENT if no such symbol was found.
+ */
+int symtab_name_to_addr(symtab_t *st, char *name, uintptr_t *addr)
+{
+	size_t i;
+	char *sname;
+	unsigned stype;
+
+	for (i = 0; i < st->sym_size / sizeof(elf_symbol_t); ++i) {
+		if (st->sym[i].st_name == 0)
+			continue;
+
+		stype = ELF_ST_TYPE(st->sym[i].st_info);
+		if (stype != STT_OBJECT && stype != STT_FUNC)
+			continue;
+
+		sname = st->strtab + st->sym[i].st_name;
+
+		if (str_cmp(sname, name) == 0) {
+			*addr = st->sym[i].st_value;
+			return EOK;
+		}
+	}
+
+	return ENOENT;
+}
+
+/** Convert symbol address to name.
+ *
+ * This function finds the symbol which starts at the highest address
+ * less than or equal to @a addr.
+ *
+ * @param st	Symbol table.
+ * @param addr	Address for lookup.
+ * @param name	Place to store pointer name of symbol, if found.
+ *		This is valid while @a st exists.
+ *
+ * @return	EOK on success or ENOENT if no matching symbol was found.
+ */
+int symtab_addr_to_name(symtab_t *st, uintptr_t addr, char **name,
+    size_t *offs)
+{
+	size_t i;
+	uintptr_t saddr, best_addr;
+	char *sname, *best_name;
+	unsigned stype;
+
+	best_name = NULL;
+	best_addr = 0;
+
+	for (i = 0; i < st->sym_size / sizeof(elf_symbol_t); ++i) {
+		if (st->sym[i].st_name == 0)
+			continue;
+
+		stype = ELF_ST_TYPE(st->sym[i].st_info);
+		if (stype != STT_OBJECT && stype != STT_FUNC &&
+		    stype != STT_NOTYPE) {
+			continue;
+		}
+
+		saddr = st->sym[i].st_value;
+		sname = st->strtab + st->sym[i].st_name;
+
+		/* An ugly hack to filter out some special ARM symbols. */
+		if (sname[0] == '$')
+			continue;
+
+		if (best_name == NULL || (saddr <= addr && saddr > best_addr)) {
+			best_name = sname;
+			best_addr = saddr;
+		}
+	}
+
+	if (best_name == NULL)
+		return ENOENT;
+
+	*name = best_name;
+	*offs = addr - best_addr;
+	return EOK;
+}
+
+/** Check if ELF header is valid.
+ *
+ * @return	EOK on success or negative error code.
+ */
+static int elf_hdr_check(elf_header_t *ehdr)
+{
+	/* TODO */
+	return EOK;
+}
+
+/** Load ELF section header.
+ *
+ * @param fd		File descriptor of ELF file.
+ * @param elf_hdr	Pointer to ELF file header in memory.
+ * @param idx		Index of section whose header to load (0 = first).
+ * @param sec_hdr	Place to store section header data.
+ *
+ * @return		EOK on success or EIO if I/O failed.
+ */
+static int section_hdr_load(int fd, const elf_header_t *elf_hdr, int idx,
+    elf_section_header_t *sec_hdr)
+{
+	int rc;
+
+	rc = lseek(fd, elf_hdr->e_shoff + idx * sizeof(elf_section_header_t),
+	    SEEK_SET);
+	if (rc == (off_t) -1)
+		return EIO;
+
+	rc = read_all(fd, sec_hdr, sizeof(elf_section_header_t));
+	if (rc != EOK)
+		return EIO;
+
+	return EOK;
+}
+
+/** Load a segment of bytes from a file and return it as a new memory block.
+ *
+ * This function fails if it cannot read exactly @a size bytes from the file.
+ *
+ * @param fd		File to read from.
+ * @param start		Position in file where to start reading.
+ * @param size		Number of bytes to read.
+ * @param ptr		Place to store pointer to newly allocated block.
+ *
+ * @return		EOK on success or EIO on failure.
+ */
+static int chunk_load(int fd, off_t start, off_t size, void **ptr)
+{
+	int rc;
+
+	rc = lseek(fd, start, SEEK_SET);
+	if (rc == (off_t) -1) {
+		printf("failed seeking chunk\n");
+		*ptr = NULL;
+		return EIO;
+	}
+
+	*ptr = malloc(size);
+	if (*ptr == NULL) {
+		printf("failed allocating memory\n");
+		return ENOMEM;
+	}
+
+	rc = read_all(fd, *ptr, size);
+	if (rc != EOK) {
+		printf("failed reading chunk\n");
+		free(*ptr);
+		*ptr = NULL;
+		return EIO;
+	}
+
+	return EOK;
+}
+
+/** Read until the buffer is read in its entirety.
+ *
+ * This function fails if it cannot read exactly @a len bytes from the file.
+ *
+ * @param fd		The file to read from.
+ * @param buf		Buffer for storing data, @a len bytes long.
+ * @param len		Number of bytes to read.
+ *
+ * @return		EOK on error, EIO if file is short or return value
+ *			from read() if reading failed.
+ */
+static int read_all(int fd, void *buf, size_t len)
+{
+	int cnt = 0;
+
+	do {
+		buf += cnt;
+		len -= cnt;
+		cnt = read(fd, buf, len);
+	} while (cnt > 0 && (len - cnt) > 0);
+
+	if (cnt < 0)
+		return cnt;
+
+	if (len - cnt > 0)
+		return EIO;
+
+	return EOK;
+}
+
+/** @}
+ */
